

#ifndef Eigener_USART_H_
#define Eigener_USART_H_ 1

#include <stdlib.h>

#ifndef F_CPU
#define F_CPU 16000000// Clock Speed
#endif

//#define FOSC 16000000// Clock Speed
#define BAUD 9600
#define MYUBRR F_CPU/16/BAUD-1

//
#define laenge_TermString	33

extern char itoabuffer[laenge_TermString];

//-- Initialisierung
	void USART_Init_8BITdata_2stopBITs( unsigned int ubrr)
	{
		/* Set baud rate */
		UBRRH = (unsigned char)(ubrr>>8);
		UBRRL = (unsigned char)ubrr;
		/* Enable receiver and transmitter */
		UCSRB = (1<<RXEN)|(1<<TXEN);
		/* Set frame format: 8data, 2stop bit */
		//-- Asynchron modus,
		UCSRC = (1<<URSEL)|(1<<USBS)|(1<<UCSZ0)|(1<<UCSZ1);
	}
	
	void USART_INIT_PC_HTerm(void)
	{
		unsigned int ubrr = MYUBRR;
		/* Set baud rate */
		UBRRH = (unsigned char)(ubrr>>8);
		UBRRL = (unsigned char)ubrr;
		/* Enable receiver and transmitter */
		UCSRB = (1<<RXEN)|(1<<TXEN);
		/* Set frame format: 8data, 2stop bit */
		//-- Asynchron modus,
		UCSRC = (1<<URSEL)|(1<<USBS)|(1<<UCSZ0)|(1<<UCSZ1);
	}
	
	void USART_Init_9BITdata_2stopBITs(unsigned int ubrr)
	{
		
		/* Set baud rate */
		UBRRH = (unsigned char)(ubrr>>8);
		UBRRL = (unsigned char)ubrr;
		/* Enable receiver and transmitter */
		UCSRB = (1<<RXEN)|(1<<TXEN);
		/* Set frame format: 9data, 2stop bit */
		//-- Asynchron modus
		UCSRB |= UCSZ2;
		UCSRC = (1<<URSEL)|(1<<USBS)|(1<<UCSZ0)|(1<<UCSZ1);
	}

void USART_Transmit( unsigned int data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) )
	;
	/* Copy ninth bit to TXB8 */
	UCSRB &= ~(1<<TXB8);
	if ( data & 0x0100 )
	UCSRB |= (1<<TXB8);
	/* Put data into buffer, sends the data */
	UDR = data;
}

//-- 9 Datenbits senden
void USART_Transmit_9Bits( unsigned int data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	
	/* Copy ninth bit to TXB8 */
	UCSRB &= ~(1<<TXB8);
	if ( data & 0x0100 )
	UCSRB |= (1<<TXB8);
	/* Put data into buffer, sends the data */
	UDR = data;
}

// unsigned int USART_Receive_9Bits( void )
// {
// 	unsigned char status, resh, resl;
// 	/* Wait for data to be received */
// 	while ( !(UCSRA & (1<<RXC)) )	;
// 	/* Get status and ninth bit, then data */
// 	/* from buffer */
// 	status = UCSRA;
// 	resh = UCSRB;
// 	resl = UDR;
// 	/* If error, return -1 */
//	if ( status & (1<<FE)|(1<<DOR)|(1<<UPE) )
// 	return -1;
// 	/* Filter the ninth bit, then return */
// 	resh = (resh >> 1) & 0x01;
// 	return ((resh << 8) | resl);
// }
//-- 5-8 Bits
unsigned char USART_Receive_5_to_8BITs( void )
{
	/* Wait for data to be received */
	while ( !(UCSRA & (1<<RXC)) );
	/* Get and return received data from buffer */
	return UDR;
}

//-- 5-8 Datenbits senden
void USART_Transmit_8Bits( unsigned char data)
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	
	UDR = data;
}

//-- String bergeben

void UART_transmit_string(char* ptr, uint8_t maxLaenge)
{
	//uint8_t a = 0;
	uint8_t a = 0;
	for (;a < maxLaenge && *(ptr+a) != '\0'; a++)
	{
		USART_Transmit_8Bits(*(ptr+a));
	}
// 
// 	if (a != maxLaenge)
// 	{USART_Transmit_8Bits(*(ptr+a));
// 	}
	
	
}

//-- String einlesen
void UART_receive_string(char* Datenpuffer, uint8_t max_Laenge)
{
	
	uint8_t a = 0;
	do
	{
		*(Datenpuffer + a) = USART_Receive_5_to_8BITs();
		
		a++;
	} while (*(Datenpuffer+(a-1)) != '\0' && a < max_Laenge);	
}


//-- Terminalausgabe

	void terminal_zeilenumbrueche(char* ptr_array_string,uint8_t max_laenge_string,uint8_t anzahl_zeilenumbrueche)
 {
	 for (uint8_t a = 0; a < anzahl_zeilenumbrueche;a++)
	 {
		 //--Zeilenumbruch senden
		 *(ptr_array_string ) = '\r';
		 *(ptr_array_string + 1) = '\0';
		 UART_transmit_string(ptr_array_string,max_laenge_string);
	 }
	 
 }
 
	void terminalSRING_zeilenumbruch_anhaengen(char* ptr_array_string,uint8_t max_laenge_string,uint8_t anzahl_zeilenumbrueche)
 {
	 uint8_t Elementnummer = 0;
	 // Ende des bestehenden strings suchen
	 for (;Elementnummer < max_laenge_string && Elementnummer < max_laenge_string ;Elementnummer++)
	 {
		 if(*(ptr_array_string + Elementnummer) == '\0')
		 {
			 break;
		 }
	 }
	 for(;anzahl_zeilenumbrueche != 0 && Elementnummer < max_laenge_string; anzahl_zeilenumbrueche--,Elementnummer++)
	 {
		 *(ptr_array_string + Elementnummer) = '\r';
	 }
	if (Elementnummer < max_laenge_string)
	{
		*(ptr_array_string + Elementnummer) = '\0';
	}
	 
 }
 
 	void terminal_uint32_tEinzelwertausgabe(char* ptr_array_string,uint32_t wert,uint8_t max_laenge_string,uint8_t radix_wert)
 {
	 for (uint8_t b = 0; b < 6; b++)
	 {
		 switch(b)
		 {
			 case 0:
			 {
				 *(ptr_array_string + b) = 'W';
				 break;
			 }
			 case 1:
			 {
				 *(ptr_array_string + b) = 'e';
				 break;
			 }
			 case 2:
			 {
				 *(ptr_array_string + b) = 'r';
				 break;
			 }
			 case 3:
			 {
				 *(ptr_array_string + b) = 't';
				 break;
			 }
			 case 4:
			 {
				 *(ptr_array_string + b) = ' ';
				 break;
			 }
			 case 5:
			 {
				 *(ptr_array_string + b) = '\0';
				 break;
			 }
		 }
	 }
	 UART_transmit_string(ptr_array_string,max_laenge_string);
	 
	 //-- Leerzeichen senden
	 *(ptr_array_string) = ' ';
	 *(ptr_array_string + 1) = '\0';
	 UART_transmit_string(ptr_array_string,max_laenge_string);
	 //-- Wert senden
	 // 	 switch(datentyp)
	 // 	 {
		 // 		 case 0: //char
		 // 		 {
			 // 			 int z = (int)*(ptr_wert);
			 // 			 itoa(z,ptr_array_string,radix_wert);
			 // 			 break;
		 // 		 }
		 // 		 case 1: // unsigned char
		 // 		 {
			 // 			 itoa(*(ptr_wert),ptr_array_string,radix_wert);
			 // 			 break;
		 // 		 }
		 // 		 case 2: // int
		 // 		 {
			 // 			 itoa(*(ptr_wert),ptr_array_string,radix_wert);
			 // 			 break;
		 // 		 }
	 // 	 }
	 ultoa(wert,ptr_array_string,radix_wert);
	 UART_transmit_string(ptr_array_string,max_laenge_string);
	 //--Zeilenumbruch senden
	 *(ptr_array_string ) = '\n';
	 *(ptr_array_string + 1) = '\0';
	 UART_transmit_string(ptr_array_string,max_laenge_string);
 }
 
	void terminal_uint8_tarray_Werteausgabe(char* ptr_array_string,uint8_t* ptr_werte,uint8_t max_laenge_string,uint8_t laenge_werte_array,uint8_t radix_wert)
 {
	 for (uint8_t a =0; a < laenge_werte_array ;a++)
	 {
		 
		 for (uint8_t b = 0; b < 6; b++)
		 {
			 switch(b)
			 {
				 case 0:
				 {
					 *(ptr_array_string + b) = 'W';
					 break;
				 }
				 case 1:
				 {
					 *(ptr_array_string + b) = 'e';
					 break;
				 }
				 case 2:
				 {
					 *(ptr_array_string + b) = 'r';
					 break;
				 }
				 case 3:
				 {
					 *(ptr_array_string + b) = 't';
					 break;
				 }
				 case 4:
				 {
					 *(ptr_array_string + b) = ' ';
					 break;
				 }
				 case 5:
				 {
					 *(ptr_array_string + b) = '\0';
					 break;
				 }
			 }
		 }
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Wertnummer senden
		 utoa(a,ptr_array_string,10);
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Leerzeichen senden
		 *(ptr_array_string) = ' ';
		 *(ptr_array_string + 1) = '\0';
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Wert senden
		 utoa(*(ptr_werte + a),ptr_array_string,radix_wert);
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //--Zeilenumbruch senden
		 *(ptr_array_string ) = '\n';
		 *(ptr_array_string + 1) = '\0';
		 UART_transmit_string(ptr_array_string,max_laenge_string);
	 }
	 //--Zeilenumbruch senden
	 *(ptr_array_string ) = '\n';
	 *(ptr_array_string + 1) = '\0';
	 UART_transmit_string(ptr_array_string,max_laenge_string);
 }

	void terminal_uint16_t_array_Werteausgabe(char* ptr_array_string,uint16_t* ptr_werte,uint8_t max_laenge_string,uint8_t laenge_werte_array,uint8_t radix_wert)
 {
	 for (uint8_t a =0; a < laenge_werte_array ;a++)
	 {
		 
		 for (uint8_t b = 0; b < 6; b++)
		 {
			 switch(b)
			 {
				 case 0:
				 {
					 *(ptr_array_string + b) = 'W';
					 break;
				 }
				 case 1:
				 {
					 *(ptr_array_string + b) = 'e';
					 break;
				 }
				 case 2:
				 {
					 *(ptr_array_string + b) = 'r';
					 break;
				 }
				 case 3:
				 {
					 *(ptr_array_string + b) = 't';
					 break;
				 }
				 case 4:
				 {
					 *(ptr_array_string + b) = ' ';
					 break;
				 }
				 case 5:
				 {
					 *(ptr_array_string + b) = '\0';
					 break;
				 }
			 }
		 }
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Wertnummer senden
		 utoa(a,ptr_array_string,10);
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Leerzeichen senden
		 *(ptr_array_string) = ' ';
		 *(ptr_array_string + 1) = '\0';
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //-- Wert senden
		 utoa(*(ptr_werte + a),ptr_array_string,radix_wert);
		 UART_transmit_string(ptr_array_string,max_laenge_string);
		 //--Zeilenumbruch senden
		 *(ptr_array_string ) = '\n';
		 *(ptr_array_string + 1) = '\0';
		 UART_transmit_string(ptr_array_string,max_laenge_string);
	 }
	 //--Zeilenumbruch senden
	 *(ptr_array_string ) = '\n';
	 *(ptr_array_string + 1) = '\0';
	 UART_transmit_string(ptr_array_string,max_laenge_string);
 }

	void terminalString_ersetzen(char Buffer[],char* ptr_array_string,uint8_t max_laenge_string)
{	
	uint8_t zaehler = 0;
	
	do
	{
		*(ptr_array_string + zaehler) = *(Buffer + zaehler);
		zaehler++;
		
	} while (*(Buffer + zaehler - 1) != '\0' && zaehler < max_laenge_string);
	
	
}

	uint8_t terminalSTRING_Anschlusselement_suchen(char* ptr_array_string,uint8_t max_laenge_string)
{
	uint8_t Elementnummer = 0;
	// Ende des bestehenden strings suchen
	for (;Elementnummer < max_laenge_string && Elementnummer < max_laenge_string ;Elementnummer++)
	{
		if(*(ptr_array_string + Elementnummer) == '\0')
		{
			break;
		}
	}
	return Elementnummer;
}

	void terminal_an_string_ankuepfen(char Buffer[],char* ptr_array_string,uint8_t max_laenge_string,uint8_t anzahl_line_feeds)
{
	uint8_t zaehler = 0;
	// Ende des bestehenden strings suchen
	for (;zaehler < max_laenge_string;zaehler++)
	{
		if(*(ptr_array_string + zaehler) == '\0')
		{
			break;
		}
	}
	//-- Line feeds einfgen
	for(; zaehler < max_laenge_string && anzahl_line_feeds; zaehler++)
	{
		// Line feed hat den asciiwert : 10
		*(ptr_array_string + zaehler) = 10;
		anzahl_line_feeds--;
	}
	
	uint8_t zaehler2 = 0;
	
	do 
	{
		*(ptr_array_string + zaehler) = *(Buffer + zaehler2);
		zaehler++;
		zaehler2++;
	} while (*(Buffer + zaehler2 - 1) != '\0' && zaehler < max_laenge_string);
	
	
}

	void USART_PC_message(char Buffer[],char* ptr_array_string)
{
	uint8_t zaehler = 0;
	
	do
	{
		*(ptr_array_string + zaehler) = *(Buffer + zaehler);
		zaehler++;
		
	} while (*(Buffer + zaehler - 1) != '\0' && zaehler < laenge_TermString);
	
	UART_transmit_string(ptr_array_string,laenge_TermString);
}

void USART_PC_message_with_uint_8(char Buffer[],char* ptr_array_string, uint8_t wert,int radix)
{
	uint8_t zaehler = 0;
	
	do
	{
		*(ptr_array_string + zaehler) = *(Buffer + zaehler);
		zaehler++;
		
	} while (*(Buffer + zaehler - 1) != '\0' && zaehler < laenge_TermString);
	
	uint8_t nr = terminalSTRING_Anschlusselement_suchen(ptr_array_string,laenge_TermString);
	utoa(wert,ptr_array_string+nr, radix);
	nr = terminalSTRING_Anschlusselement_suchen(ptr_array_string,laenge_TermString);
	
	// Zeilenumbruch
// 	if (!(nr> laenge_TermString-2) || (nr==1) || nr ==2)
// 	{
// 		*(ptr_array_string+nr)='\n';
// 		*(ptr_array_string+nr+1)='\0';
// 	}
	UART_transmit_string(ptr_array_string,laenge_TermString);
}



#endif  /*Eigener_USART_H_*/ 