/*
 * nRF24L01_Tutorial_Sender.c
 *
 * Created: 06.01.2012 20:15:04
 *  Author: Ernst Buchmann
 */ 

			//Define F_CPU if not done 
#define F_CPU 16000000UL


#define __AVR_ATmega8__ 1

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdlib.h>
#include "Eigener_USART.h"
#include "spi.h"
#include "wl_module.h"
#include "nRF24L01.h"


volatile uint8_t timercounter;

//////////////////////////////////////////////////////////////////////////
// debug:
volatile uint8_t flags=0;
volatile uint8_t status_nrf=0;
#define  gesendet (1<<0)
#define nicht_gesendet (1<<1)
#define ISR_INT0_Aufruf (1<<2)
#define if_sende_befehl (1<<3)
#define StatusAenderung (1<<4)

#define Debugklingel (PORTC ^= (1<<5))

//////////////////////////////////////////////////////////////////////////

int main(void)
{
	//debug
	DDRC |= (1<<5);
	char itoabuffer[laenge_TermString];
	USART_INIT_PC_HTerm();
	_delay_ms(7000);
	
	//hallo PC
	for (int i=0;i<10;i++)
	{
		_delay_ms(1000);
		USART_PC_message("\n", itoabuffer);
	}
	USART_PC_message("Eingeschaltet...\n",itoabuffer);
	
	uint8_t payload[wl_module_PAYLOAD];		//Array for Payload
	uint8_t maincounter =0;
	uint8_t k;
	
	//initialise nRF24L01+ Module
    USART_PC_message("Beginne INIT...\n",itoabuffer);
	wl_module_init();	
	_delay_ms(50);		//wait for nRF24L01+ Module	
	USART_PC_message("INIT abgeschlossen...\n",itoabuffer);	
	sei();
	
	USART_PC_message("Beginne CONFIG...\n",itoabuffer);	
	wl_module_tx_config(wl_module_TX_NR_0);		//Config Module
	USART_PC_message("CONFIG abgeschlossen...\n",itoabuffer);	
	
		
	for (int i=0;i<2;i++)
	{
		_delay_ms(1000);
		USART_PC_message("\n", itoabuffer);
	}
	
	TCCR0 |= ( (1<<CS02) | (1<<CS00));		//Prescaler auf 1024 ATMEGA8
	TIMSK |= ( (1<<TOIE0));					//enable TOVF ATMEGA8
		
	
    while(1)
    {
				
		
				
		if (timercounter >= 60)			//30 entspricht ~1 Sekunde bei 8MHz// 16MHZ -> 60!
			{
				timercounter = 0;
				//////////////////////////////////////////////////////////////////////////
				// debug:
				uint8_t registerwerte[21];
				for (uint8_t a = 0; a<21; a++)
				{
					registerwerte[a] = 0;
				}	
				wl_module_read_register(0,registerwerte,21);
				USART_PC_message("\n\nWerte am Stueck auslesen\n",itoabuffer);
				for (uint8_t a=0; a<21; a++)
				{
					USART_PC_message("RegADR",itoabuffer);
					USART_PC_message_with_uint_8("",itoabuffer,a,10);
					USART_PC_message("\t",itoabuffer);
					USART_PC_message_with_uint_8("",itoabuffer,registerwerte[a],2);
					USART_PC_message("\n",itoabuffer);
				}
				
				
				USART_PC_message("\n\nWerte einzeln ausgelesen\n",itoabuffer);			
				for (uint8_t a = 0; a<21; a++)
				{
					wl_module_read_register(a,registerwerte+a,1);
				}							
				
				for (uint8_t a=0; a<21; a++)
				{
					USART_PC_message("RegADR",itoabuffer);
					USART_PC_message_with_uint_8("",itoabuffer,a,10);
					USART_PC_message("\t",itoabuffer);
					USART_PC_message_with_uint_8("",itoabuffer,registerwerte[a],2);
					USART_PC_message("\n",itoabuffer);
				}			
				// ENde Debug
				//////////////////////////////////////////////////////////////////////////
				for (k=0; k<=wl_module_PAYLOAD-1; k++)
				{
					payload[k] = k;
				}
			
				payload[0] = maincounter;
				payload[1] = maincounter+1;				
			
				wl_module_send(payload,wl_module_PAYLOAD);
				
				USART_PC_message("wl_module_send\n",itoabuffer);
				
				maincounter++;
				if (maincounter >250)
				{
					maincounter = 0; 
				}
				//uint8_t status_nfr = wl_module_get_status();
				
				//USART_PC_message_with_uint_8("Status_NRF1:",itoabuffer,10,2);
				
			}
    }
}

ISR(TIMER0_OVF_vect)
{
	timercounter++;
}


// void pseudo_ISR_INTO()
// {
// 	USART_PC_message("ISR_INT0_Aufruf\n\0",itoabuffer);
// 	uint8_t status;
// 	
// 	// Read wl_module status
// 	wl_module_CSN_lo;                               // Pull down chip select
// 	status = spi_fast_shift(NOP);					// Read status register
// 	wl_module_CSN_hi;                               // Pull up chip select
// 	
// 	
// 	USART_PC_message_with_uint_8("status: ", itoabuffer,status,2);
// 	if (status & (1<<TX_DS))							// IRQ: Package has been sent
// 	{
// 		USART_PC_message("gesendet \n\0",itoabuffer);
// 		wl_module_config_register(STATUS, (1<<TX_DS));	//Clear Interrupt Bit
// 		PTX=0;
// 	}
// 	
// 	if (status & (1<<MAX_RT))							// IRQ: Package has not been sent, send again
// 	{
// 		USART_PC_message("nicht gesendet \n\0",itoabuffer);
// 		wl_module_config_register(STATUS, (1<<MAX_RT));	// Clear Interrupt Bit
// 		wl_module_CE_hi;								// Start transmission
// 		_delay_us(10);
// 		wl_module_CE_lo;
// 	}
// 	
// 	if (status & (1<<TX_FULL))							//TX_FIFO Full <-- this is not an IRQ
// 	{
// 		USART_PC_message("fifo_full \n\0",itoabuffer);
// 		wl_module_CSN_lo;                               // Pull down chip select
// 		spi_fast_shift(FLUSH_TX);						// Flush TX-FIFO
// 		wl_module_CSN_hi;                               // Pull up chip select
// 	}
// 	
// }

//Unterscheidung je nach verwendeten C
#if defined(__AVR_ATmega8__)
ISR(INT0_vect)
#endif // __AVR_ATmega8__
#if defined(__AVR_ATmega88A__)
ISR(INT0_vect)
#endif // __AVR_ATmega88A__
#if defined(__AVR_ATmega168__)
ISR(PCINT2_vect) 
#endif // __AVR_ATmega168__  
// Interrupt handler 
{
	//USART_PC_message("ISR_INT0_Aufruf\n\0",itoabuffer);
    uint8_t status;   
    
        // Read wl_module status 
        wl_module_CSN_lo;                               // Pull down chip select
        status = spi_fast_shift(NOP);					// Read status register
        wl_module_CSN_hi;                               // Pull up chip select
		
		
		if (status & (1<<TX_DS))							// IRQ: Package has been sent
		{
		//	USART_PC_message("gesendet \n\0",itoabuffer);
			wl_module_config_register(STATUS, (1<<TX_DS));	//Clear Interrupt Bit
			PTX=0;
		}
		
		if (status & (1<<MAX_RT))							// IRQ: Package has not been sent, send again
		{
		//	USART_PC_message("nicht gesendet \n\0",itoabuffer);
			wl_module_config_register(STATUS, (1<<MAX_RT));	// Clear Interrupt Bit
			wl_module_CE_hi;								// Start transmission
			_delay_us(10);								
			wl_module_CE_lo;
		}
		
		if (status & (1<<TX_FULL))							//TX_FIFO Full <-- this is not an IRQ
		{
			wl_module_CSN_lo;                               // Pull down chip select
			spi_fast_shift(FLUSH_TX);						// Flush TX-FIFO
			wl_module_CSN_hi;                               // Pull up chip select
		}
		
}

